//+------------------------------------------------------------------+
//|                               Forex Generator version 4.4        |
//|                                 Copyright (C) 2011, Etasoft Inc. |
//|                                    http://www.forexgenerator.com |
//+------------------------------------------------------------------+
// Keywords: indicator developer, Forex indicator builder, create forex indicator, MT4


#property copyright "Your copyright"
#property link "Link to your website"
#property indicator_separate_window
#property indicator_buffers 1

#property indicator_color1 Blue
#property indicator_width1 2


//extern int numDays = 5;
extern int numBars = 30;

extern int avgPeriod = 10;  // how many bars back to average the rolling separation volume
double prePrice, totPrePrice, totVol;
// local variables

double Buffer1[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   //int j;
    //ObjectsDeleteAll();      // clear the chart
    IndicatorShortName("Active Boundaries");
    //IndicatorDigits(Digits);
    IndicatorBuffers(1);  
    SetIndexBuffer(0, Buffer1);
    SetIndexStyle(0, DRAW_LINE);
    
    /* for(j = Bars; j > Bars - numBars; j--) {
        prePrice = Close[j] * Volume[j];
        totPrePrice += prePrice;
	     totVol += Volume[j];
    }*/
    
    return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
    ObjectsDeleteAll();
    
    
    return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator start function                                  |
//+------------------------------------------------------------------+
int start()
{
    int i, j, limit;
    double avgPrice, avgProfit, AB;
    int counted_bars=IndicatorCounted();
   // static int flag = 0;
   // int numBarsInPeriod;
    
    
    
    if(counted_bars < 0) return(-1);
    if(counted_bars > 0) counted_bars--;
    
    limit = Bars  - counted_bars -2;
    

    // pre processing - calculate the very first window of numDays at the beginning of chart
   
 /*   if (flag == 0) {
    flag=1;
    Print("f=",flag);
    Print("lim=",limit);
    for(j = limit; j > limit - numBars; j--) {
        prePrice = Close[j] * Volume[j];
        totPrePrice += prePrice;
	     totVol += Volume[j];
	     Print("j=",j);
    }
    }*/
    // main loop
    for(i = limit; i >= 1; i--)
    {
       // add latest minute info and subtract trailing minute from numDays before
       prePrice = Close[i] * Volume[i];
       totPrePrice += prePrice;
       prePrice = Close[i + numBars] * Volume[i + numBars];
       totPrePrice -= prePrice;
	    totVol += Volume[i] - Volume[i + numBars]; 
	    
       avgPrice = totPrePrice / totVol;
       avgProfit = (Close[i] - avgPrice) / avgPrice;
       AB = avgProfit * 100;
       Buffer1[i] = AB;
    }
    return(0);
}



